/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.kbss.ejaspringapp.backing;

import cz.cvut.kbss.ejaspringapp.dto.UserDTO;
import cz.cvut.kbss.ejaspringapp.service.UserServiceIface;
import java.util.List;
import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.component.UIInput;
import javax.faces.context.FacesContext;
import javax.faces.validator.ValidatorException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

/**
 *
 * @author mickapa1
 */
@Component("userBackingBean") //pod nazvem userBacking bean bude tato komponenta pristupna z JSF
@Scope("request") //pro kazdy request nova instance
public class UserBackingBean {
    private UserDTO user;
    private String password;

    @Autowired
    private UserServiceIface userService;
    public UserBackingBean() {
        this.user = new UserDTO();
    }

    /**
     * Save the user
     * @return 
     */
    public String saveUser(){
        userService.saveUser(user, password);
        this.user = new UserDTO(); //reset the inputs
        this.password = null;
        return "success";
    }
    /**
     * Get all users stored in the database
     * @return 
     */
    public List<UserDTO> getUsers(){
        return userService.getAllUsers();
    }    
    
    public String deleteUser(Long id){
        userService.deleteUser(id);
        return "success";
    }
    
    /**
     * Validate username, if its not a duplicate
     * @param context
     * @param component
     * @param value
     * @throws ValidatorException 
     */
    public void validateUsername(FacesContext context, UIComponent component, Object value) throws ValidatorException{
        if(userService.getUserByUserName((String) value) != null){
            throw new ValidatorException(new FacesMessage("Duplicate username: " + value));
        }
    }
    
    public UserDTO getUser() {
        return user;
    }

    /**
     * @return the password
     */
    public String getPassword() {
        return password;
    }

    /**
     * @param password the password to set
     */
    public void setPassword(String password) {
        this.password = password;
    }
    
    
}
