package cz.cvut.kbss.ejaspringapp.bo;

import java.io.Serializable;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.MappedSuperclass;
import org.hibernate.annotations.GenericGenerator;

/**
 * AbstractBusinessObject is superobject for all entity beans.
 *
 * @author Pavel Micka (mickapa1@fel.cvut.cz)
 */
@SuppressWarnings("serial")
@MappedSuperclass
public abstract class AbstractBusinessObject implements Serializable {
    @Id
    @GeneratedValue(generator="system-sequence")
    @GenericGenerator(name="system-sequence", strategy = "sequence")
    protected Long id;
   
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        } else if (!(obj instanceof AbstractBusinessObject)) {
            return false;
        }
        return ((AbstractBusinessObject) obj).getId().equals(this.getId());
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 97 * hash + (this.id != null ? this.id.hashCode() : 0);
        return hash;
    }
}
