/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.kbss.ejaspringapp.dto;

/**
 * DTO == Data transfer object slouzi k prenosu informace mezi aplikaci a jejim
 * okolim. Za jadro aplikace je povazovano vse az do servisni vrstvy, ktera
 * odstinuje (encapsulates) vnitrni implmentaci pomoci jasne daneho rozhrani.
 * 
 * Aplikace komunikuje se svym okolim striktne pomoci DTO, nikde ne za pouziti BO,
 * jelikoz BO nemusi mit na druhe strane dratu kontext (transakce se uzavrou na
 * service layeru, stejne tak je na service layeru zabezpeceni a BO jako takove 
 * mohou mit nainjektovany v sobe ruzne sluzby, ktere na pripadnem tlustem klientu 
 * samozrejme vubec nejsou).
 * 
 * @author mickapa1
 */
public class UserDTO extends AbstractDTO {

    private String username;
    private String name;
    private String surname;

    public UserDTO() {
    }

    public UserDTO(String username, String name, String surname) {
        this.username = username;
        this.name = name;
        this.surname = surname;
    }
    public UserDTO(Long id, String username, String name, String surname) {
        this.id = id;
        this.username = username;
        this.name = name;
        this.surname = surname;
    }    

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getSurname() {
        return surname;
    }

    public void setSurname(String surname) {
        this.surname = surname;
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }
    
    
}
