/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.kbss.ejaspringapp.service;

import cz.cvut.kbss.ejaspringapp.bo.User;
import cz.cvut.kbss.ejaspringapp.dao.GenericDAOIface;
import cz.cvut.kbss.ejaspringapp.dto.UserDTO;
import cz.cvut.kbss.ejaspringapp.support.FacesUtil;
import java.util.ArrayList;
import java.util.List;
import javax.faces.application.FacesMessage;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 *
 * @author mickapa1
 */
@Service("userService")
public class UserService implements UserServiceIface{
    @Autowired
    private GenericDAOIface genericDAO;
    
    public List<UserDTO> getAllUsers() {
        List<User> users = genericDAO.getAll(User.class);
        List<UserDTO> dtos = new ArrayList<UserDTO>();
        for(User u : users){
            dtos.add(new UserDTO(u.getId(), u.getUsername(), u.getName(), u.getSurname()));
        }
        return dtos;
    }


    public UserDTO getUserByUserName(String userName) {
        List<User> list = genericDAO.getByProperty("username", userName, User.class);
        if(list.isEmpty()){
            return null;
        } else if(list.size() == 1){
            User u = list.get(0);
            return new UserDTO(u.getId(), u.getUsername(), u.getName(), u.getSurname());
        } else throw new IllegalStateException("Illegal count of users with the same username: " + list.size());
        
        
    }

    public UserDTO saveUser(UserDTO user, String password) {
        User u = new User(user, password);
        u = genericDAO.saveOrUpdate(u);
        FacesUtil.addMessage(new FacesMessage(FacesMessage.SEVERITY_INFO, "User saved", "The user was successfully saved"));
        
        return new UserDTO(u.getId(), u.getUsername(), u.getName(), u.getSurname());
    }

    public void deleteUser(Long id) {
        genericDAO.removeById(id, User.class);
        FacesUtil.addMessage(new FacesMessage(FacesMessage.SEVERITY_INFO, "User deleted", "The user was successfully deleted"));
    }

    
}
