/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.kbss.ejaspringapp.service;

import cz.cvut.kbss.ejaspringapp.dto.UserDTO;
import java.util.List;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author mickapa1
 */
public interface UserServiceIface {
    /**
     * Get all users saved in the system
     * @return 
     */
    @Transactional(readOnly=true)
    public List<UserDTO> getAllUsers();
    /**
     * Create a new user, or update the existing one (has id set)
     * @param user user to be saved
     * @return saved entity DTO
     */
    @Transactional
    public UserDTO saveUser(UserDTO user, String password);
    
    @Transactional(readOnly=true)
    public UserDTO getUserByUserName(String name);
    
    /**
     * Delete the user with the specified id
     * @param id user identifier
     */
    @Transactional
    public void deleteUser(Long id);
}
